#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf jfsutils-1.1.15.tar.gz
    cd jfsutils-1.1.15
    ./configure --prefix=/usr --sysconfdir=/etc --localstatedir=/var
    make
    strip -R .note -R .comment fsck/jfs_fsck mkfs/jfs_mkfs
    mkdir -p ../jfs-tune/sbin
    cp fsck/jfs_fsck ../jfs-fsck/sbin/
    cp mkfs/jfs_mkfs ../jfs-mkfs/sbin/
    cp tune/jfs_tune ../jfs-tune/sbin/
    cd ..
    rm -rf jfsutils-1.1.15
}

mkdir -p jfs-fsck/sbin
ln -sf jfs_fsck jfs-fsck/sbin/fsck.jfs
mkdir -p jfs-mkfs/sbin
ln -sf jfs_mkfs jfs-mkfs/sbin/mkfs.jfs

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
